"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var visitor_1 = require("./visitor");
var autoBind = require("auto-bind");
var TsIntrospectionVisitor = /** @class */ (function (_super) {
    __extends(TsIntrospectionVisitor, _super);
    function TsIntrospectionVisitor(pluginConfig, typesToInclude) {
        if (pluginConfig === void 0) { pluginConfig = {}; }
        var _this = _super.call(this, pluginConfig) || this;
        _this.typesToInclude = [];
        _this.typesToInclude = typesToInclude;
        autoBind(_this);
        return _this;
    }
    TsIntrospectionVisitor.prototype.DirectiveDefinition = function () {
        return null;
    };
    TsIntrospectionVisitor.prototype.ObjectTypeDefinition = function (node, key, parent) {
        var name = node.name;
        if (this.typesToInclude.some(function (type) { return type.name === name; })) {
            return _super.prototype.ObjectTypeDefinition.call(this, node, key, parent);
        }
        return null;
    };
    TsIntrospectionVisitor.prototype.EnumTypeDefinition = function (node) {
        var name = node.name;
        if (this.typesToInclude.some(function (type) { return type.name === name; })) {
            return _super.prototype.EnumTypeDefinition.call(this, node);
        }
        return null;
    };
    return TsIntrospectionVisitor;
}(visitor_1.TsVisitor));
exports.TsIntrospectionVisitor = TsIntrospectionVisitor;
//# sourceMappingURL=introspection-visitor.js.map